// limniseul2019.pde
// 16 1 2019
// 
// Ouvre un fichier .csv de data limnimetriques au format:
// Date,Hauteur
// 17.03.2016 15:40,104.6
// 17.03.2016 16:20,104.6
// ...
//

import java.util.Date;
import java.text.SimpleDateFormat;

// String LimniNom = "chalette_un_an.csv";
// int NbrLigne = 16045; // chalette_un_an.csv

String LimniNom = "chalette_6_mois.csv";
int NbrLigne = 7418; // chalette_6_mois.csv

int IndiceLimni = 0; // = numero de la ligne

SimpleDateFormat formatter = new SimpleDateFormat("dd.MM.yy HH:mm");

int Crue = 1800; // en mm
int Crue1 = 1600; // en mm
int Crue2 = 1400; // en mm
int PasCrue = 1300; // en mm

// 24 x 60 x 60 = 86400 sec = 24h
// 365 jours = 31 536 000 sec
// Temps reel en sec = Temps sketch en msec * EchelleTemps
// par exemple avec EchelleTemps = 172:
// 172000 sec = 1000 x 172
// 48 h = 172800 sec reel = 1000 msec sketch * 172 environ
// donc 48h reel est joué en 1 sec de sketch si EchelleTemps = 172
// donc 1 an reel est joué en 1 sec x 365 / 2 de sketch = 182 sec = 3 minutes

int EchelleTemps = 40; // 
int EchelleTempsRalenti = 4; // 4
int EchelleTempsRalenti1 = 4; // 4
int EchelleTempsRalenti2 = 10; // 10
int EchelleTempsNormal = 40;

// par exemple avec EchelleTemps = 40:
// 11h = 40000 sec = 1000 x 40
// donc   11h reel est joué en 1 sec de sketch
// donc 6mois reel est joué en 1 sec x 6 x 30j x 24h / 11h = 392sec = 6min 30sec de sketch
// Oui mesure avec les 3 EchelleTempsRalenti = 40
// 745sec = 12min 25sec mesure avec EchelleTempsRalenti = 4 4 10
// Avec 80 au lieu de 40 le sketch est joue 2 x plus vite: en 3min 15sec
// Avec 20 au lieu de 40 le sketch est joue 2 x plus lentement: en 13min

Table Tableau;
int iii = 0;
int[] LimniHauteur = new int[NbrLigne]; // en mm
int[] LimniTemps   = new int[NbrLigne]; // en sec

int NbrMesure = 1;
int Cycle = 0;
// int TempsMillis, TempsDecal, TempsPasse, TempsAvant; // en ms
int TempsPasse, TempsAvant; // en ms

String sss;
Date date;
int TempsPremier, TempsPasseReel, TempsReel;  // en sec reel
boolean NouveauCycle = false;

int Hauteurmm;
int Attente = 500; // 3000ms
boolean Jattend = false;
float hhh, LimniMini, LimniMaxi;
int Temps, TempsPause;

void setuplimniseul() {
  long ddd = 0; // en msec
  float hhhh;
  TempsPremier = 2000000000; // en sec
  Tableau = loadTable(LimniNom, "header");
  //println("Chargement de " + LimniNom);
  NbrMesure = Tableau.getRowCount();
  //println(NbrMesure + " Mesures");
  LimniMini = 1000;
  LimniMaxi = -1000;
  iii = 0;
  for (TableRow row : Tableau.rows()) { 
    hhhh = row.getFloat("Hauteur");    // en cm
    if (hhhh < LimniMini) LimniMini = hhhh;
    if (hhhh > LimniMaxi) LimniMaxi = hhhh;
    sss = row.getString("Date");
    try {
      date = formatter.parse(sss);
      ddd = date.getTime(); // en msec
    }
    catch (Exception e) {
      println("Zut  " + iii);
      e.printStackTrace();
    }
    LimniHauteur[iii] = int(hhhh * 10) ; 
    ddd = ddd / 1000; // en sec
    LimniTemps[iii] = (int)ddd;
    if ((iii == 0) & (TempsPremier > (int)ddd)) {
      TempsPremier = (int)ddd;
      println("TempsPremier = " + TempsPremier);
    }
    if (iii < 5) println(iii + "   " + date + "   " + LimniTemps[iii] + "   " + hhhh + " cm");
    iii = iii + 1;
  }

  //println("Minimum = " + LimniMini + " cm");
  //println("Maximum = " + LimniMaxi + " cm");
  //println("Difference = " + (LimniMaxi - LimniMini) + " cm");
  //println();
  //println("TempsPremier=" + TempsPremier);
  //println();
  LimniMini = 0;

  int DerniereDate = TempsPremier;
  for (iii = 0; iii < NbrLigne; iii++) {
    if (LimniTemps[iii] > 0) {
      LimniTemps[iii] = LimniTemps[iii] - TempsPremier;
      DerniereDate = LimniTemps[iii];
    } else LimniTemps[iii] = DerniereDate;
  }
  DebutCycle();
}

void drawLimniseul() {
  int TempsMillis;
  TempsMillis    = millis() - TempsPause;     // en ms sketch
  TempsPasse     = TempsMillis - TempsAvant;  // en ms sketch
  TempsAvant     = TempsMillis;               // en ms sketch
  TempsPasseReel = TempsPasse * EchelleTemps; // en sec reel 
  TempsReel      = TempsReel + TempsPasseReel;// en sec reel

  // println("LimniHauteur[IndiceLimni]=" + LimniHauteur[IndiceLimni]);

  if (LimniHauteur[IndiceLimni] < PasCrue) { // en mm
    ChangeEchelle(EchelleTempsNormal); // Retour normal quand hauteur <PasCrue = 1600mm
  }
  if (LimniHauteur[IndiceLimni] > Crue2) { // en mm
    ChangeEchelle(EchelleTempsRalenti2); // EchelleTempsRalenti2 quandhauteur > Crue2 = 1700mm
  }
  if (LimniHauteur[IndiceLimni] > Crue1) { // en mm
    ChangeEchelle(EchelleTempsRalenti1); // 1EchelleTempsRalenti1 quandhauteur > Crue1 = 1900mm
  }
  if (LimniHauteur[IndiceLimni] > Crue) { // en mm
    ChangeEchelle(EchelleTempsRalenti); // EchelleTempsRalenti quandhauteur > Crue = 2100mm
  }

  if (NouveauCycle) {
    IndiceLimni = 0;
    DebutCycle();
  }
}

void CalculIndiceLimni() {
  boolean Flag = true;
  while ( (LimniTemps[IndiceLimni] < TempsReel) & Flag ) {
    IndiceLimni = IndiceLimni + 1;
    // if (AfficheConsole) println("IndiceLimni=" + IndiceLimni + "  LimniTemps[IndiceLimni]=" + LimniTemps[IndiceLimni] + "sec");
    if (IndiceLimni > LimniHauteur.length - 1) {
      IndiceLimni = LimniHauteur.length - 1;
      Flag = false;
      NouveauCycle = true; // derniere Station
    }
  }
}

void DebutCycle() {
  // IndiceLimni = 0;
  // TempsMillis = 0;
  TempsPasse = 0;
  // TempsDecal = millis();
  TempsPause = millis();
  TempsAvant = 0;
  TempsReel = 0;
  EchelleTemps= EchelleTempsNormal;
  Cycle = Cycle + 1;
  NouveauCycle = false;
}

void ChangeEchelle(int Echelle) {
  if (EchelleTemps != Echelle) EchelleTemps = Echelle;
}